<template>
  <div>
    <ob-table
        :columns="columns"
        :items="documents"
        :functionalPanel="true"
        :show-add-button="true"
        @add="$refs['add-new-document'].open()"
    >
      <template v-slot:loadScans="{data}">
        <ObUploader
          v-if="Object.keys(data.item.files).length"
          :is-read-only="true"
          :value="{
            uuid: data.item.files[0].uuid,
            file: {
              name: data.item.files[0].name ? data.item.files[0].name : 'Без названия'
            }
          }"
        />
      </template>
      <div slot="deleteDocument" slot-scope="{ data }">
        <ob-menu-dropdown :items="getDropdownItems(data)"/>
      </div>
    </ob-table>
    <ob-modal
        ref="add-new-document"
        title="Новый документ"
        title-second="Добавление"
        size="medium"
    >
      <form-add @closeModal="$refs['add-new-document'].close()"/>
    </ob-modal>

    <ObModal
        ref="delete-modal"
        size="small"
        title="Удалить документ?"
        :is-error="true"
        :is-show-controls="true"
        ok-text="Удалить"
        cancel-text="Отменить"
        @submit="onDelete(document)"
    >
      <div>Тип документа: {{document.docTypeTitle}}</div>
    </ObModal>
  </div>
</template>

<script>
  import ObTable from "common-components/src/obComponents/obTable";
  import ObUploader from "common-components/src/obComponents/obUploader";
  import ObMenuDropdown from "common-components/src/obComponents/obMenuDropdown";
  import ObModal from "common-components/src/obComponents/obModal";
  import FormAdd from "./formAdd";
  import {mapGetters, mapActions} from "vuex";
  import moment from "moment";

  export default {
    name: "documents",
    components: {
      ObTable,
      ObUploader,
      ObMenuDropdown,
      ObModal,
      FormAdd
    },
    data() {
      return {
        document: {}
      }
    },
    computed: {
      ...mapGetters({
        documents: 'documents/documents'
      }),
      columns() {
        return [
          {
            title: '№',
            key: 'number',
            html: ({number, is_active}) => `<span class="${!is_active ? 'document__not-active' : ''}">${number}</span>`
          },
          {
            title: 'тип документа',
            key: 'docTypeTitle',
            html: ({docTypeTitle, archivedDt}) =>
              `<span class="${archivedDt ? 'document__not-active document__strike' : ''}">${docTypeTitle}</span>`
          },
          {
            title: 'загруженные сканы',
            key: 'files',
            slotName: 'loadScans'
          },
          {
            title: 'Комментарий',
            key: 'comment',
            html: ({comment, archivedDt}) => `<span class="${archivedDt ? 'document__not-active' : ''}">${comment}</span>`
          },
          {
            title: 'Изменен',
            key: 'updatedDt',
            html: ({updatedDt, archivedDt}) =>
              `<span class="${archivedDt ? 'document__not-active' : ''}">${moment(updatedDt).format('DD.YY.YYYY, HH:mm')}</span>`
          },
          {
            title: '',
            key: 'delete',
            slotName: 'deleteDocument'
          }
        ]
      }
    },
    mounted() {
      this.getDocuments()
    },
    methods: {
      ...mapActions({
        getDocuments: 'documents/getDocuments',
        deleteDocument: 'documents/deleteDocument',
      }),
      onUploadFile() {
        console.log('sss')
      },
      getDropdownItems({item}) {
        return [
          {
            title: 'Удалить документ',
            className: 'menu-button-danger',
            method: () => {
              this.document = item;
              this.$refs['delete-modal'].open();
            }
          }
        ]
      },
      onDelete({uuid}) {
        this.deleteDocument(uuid).then(() => {
          this.$notification({
            type: 'system_notification_success',
            message: 'Документ удален'
          });
          this.$refs['delete-modal'].close();
        })
      }
    }
  }
</script>

<style lang="scss">
  .document {
    &__scan-tabs {
      color: $color-blue-navy-blue;
      background: $blue-250;
      border-radius: 10px;
      margin: 5px 3px;
      padding: 5px 12px;
    }
    &__not-active {
      color: $gray-slate;
    }
    &__strike {
      letter-spacing: 0.2px;
      text-decoration-line: line-through;
    }
  }
</style>
